### PersefoneDesktop - a GUI to the Persefone model of agriculture and ecosystems
###
### This file links the QML UI designs to the underlying model.
###

## For references, see:
## - https://github.com/barche/QML.jl
## - https://github.com/barche/QmlJuliaExamples
## - https://doc.qt.io/qt-6/qtquick-index.html

global running::Bool = false
global model::Union{AgentBasedModel,Missing} = missing
global progress::Float64 = 0.0

function newsimulation()
    global running, model, progress
    running = false
    progress = 0.0
    model = Persefone.initialise()
    println("Model initialised.")
end

function nextstep()
    global model, progress
    Persefone.stepsimulation!(model)
    progress = (model.date-@param(core.startdate)) / (@param(core.enddate)-model.date)
    println("Updated model: $(model.date-Day(1))")
end

function progress()
    global model, progress
    #todo
end

@qmlfunction newsimulation nextstep progress

"""
    launch()

The main function that creates the application.
"""
function launch()
    global running, model, progress
    # absolute path in case working dir is overridden
    qml_file = joinpath(dirname(@__FILE__), "main.qml")
    loadqml(qml_file,
            properties = JuliaPropertyMap("running" => running,
                                          "model" => model,
                                          "date" => model.date,
                                          "progress" => progress))
    exec()
    println("Launched Persefone Desktop.")
end
